VERSION 5.00
Begin VB.Form WhiteNoiseForm 
   BorderStyle     =   0  'None
   Caption         =   "White Noise"
   ClientHeight    =   14715
   ClientLeft      =   1650
   ClientTop       =   1545
   ClientWidth     =   6585
   BeginProperty Font 
      Name            =   "MS Sans Serif"
      Size            =   24
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   ForeColor       =   &H00FF0000&
   Icon            =   "WhiteNoise.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   981
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   439
   ShowInTaskbar   =   0   'False
   WindowState     =   2  'Maximized
End
Attribute VB_Name = "WhiteNoiseForm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Private Type BITMAPINFOHEADER
    biSize As Long
    biWidth As Long
    biHeight As Long
    biPlanes As Integer
    biBitCount As Integer
    biCompression As Long
    biSizeImage As Long
    biXPelsPerMeter As Long
    biYPelsPerMeter As Long
    biClrUsed As Long
    biClrImportant As Long
End Type
Private Type BITMAPINFO
    bmiHeader As BITMAPINFOHEADER
    bmiColors(2) As Long
End Type
Private Declare Function StretchDIBits Lib "gdi32" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long, ByVal dx As Long, ByVal dy As Long, ByVal SrcX As Long, ByVal SrcY As Long, ByVal wSrcWidth As Long, ByVal wSrcHeight As Long, lpBits As Any, lpBitsInfo As BITMAPINFO, ByVal wUsage As Long, ByVal dwRop As Long) As Long
Private Declare Function TextOut Lib "gdi32" Alias "TextOutA" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long, ByVal lpString As String, ByVal nCount As Long) As Long

Private Sub Form_Click() 'End program with a click
    End
End Sub

Private Sub Form_Activate()
    'Variables
    Dim RandomBits() As Integer 'The bitmap bits - Long would technically work faster as it would take half the number of loop iterations, but doesn't work well since VB's random number generator goes from .0001 to .9999 so too many digits are ignored
    Dim TheBitmapInfo As BITMAPINFO
    Dim TheWidth As Long, TheHeight As Long
    Dim StartTickCount As Single, TotalFrames As Integer, LastFrames As Integer 'FPS counters
    Dim i As Long 'Loop counter
    
    'Setup variables
    TheWidth = Me.ScaleWidth
    TheHeight = Me.ScaleHeight
    ReDim RandomBits(0 To TheWidth * TheHeight \ 16 - 1)
    With TheBitmapInfo.bmiHeader
        .biSize = Len(TheBitmapInfo.bmiHeader)
        .biWidth = TheWidth
        .biHeight = TheHeight
        .biPlanes = 1
        .biBitCount = 1
        .biClrUsed = 2 '2 colors
        .biClrImportant = 2 '2 colors
    End With
    TheBitmapInfo.bmiColors(0) = &HFFFFFF 'White
    TheBitmapInfo.bmiColors(1) = 0 'Black
    StartTickCount = Timer
    TotalFrames = 0
    LastFrames = 0
    
    'Main loop
    Do
        'Output random data
        For i = 0 To UBound(RandomBits)
            RandomBits(i) = Rnd * 65535 - 32768
            If i Mod 500 = 0 Then Randomize Timer 'Makes data more random but slows down FPS on my machine from 65 to 50 (23%)
        Next i
        
        StretchDIBits Me.hdc, 0, 0, TheWidth, TheHeight, 0, 0, TheWidth, TheHeight, RandomBits(0), TheBitmapInfo, 0, vbSrcCopy 'Copy data to form
        TextOut Me.hdc, 0, 0, Trim$(LastFrames), Len(Trim$(LastFrames)) 'Output FPS
        DoEvents 'Listen for mouse click
        TotalFrames = TotalFrames + 1 'Increment frame counter
        If Timer - StartTickCount > 1 Then 'Every second update the FPS
            LastFrames = TotalFrames
            TotalFrames = 0
            StartTickCount = StartTickCount + 1
        End If
    Loop
End Sub
